﻿using System.Collections.Generic;
using System.ComponentModel;
using System.Runtime.CompilerServices;
using WpfApplication1.Annotations;

namespace WpfApplication1
{
    public class ViewModel : INotifyPropertyChanged
    {
        private List<Person> _people;
        private Person _selectedPerson;

        public Person SelectedPerson
        {
            get { return _selectedPerson; }
            set { _selectedPerson = value; OnPropertyChanged(); }
        }

        public List<Person> People
        {
            get { return _people; }
            set { _people = value; }
        }

        public ViewModel()
        {
            this.People = new List<Person>
            {
                new Person()
                {
                    Name = "Bob Burger",
                    Email = "bob.burger@milkyway.com"
                },
                new Person()
                {
                    Name = "Jack Longtoes",
                    Email = "jack.longtoes@bottoms.up"
                },
                new Person()
                {
                    Name = "Jake Sully",
                    Email = "jake.sully@pandora.space"
                }
            };
        }

        public event PropertyChangedEventHandler PropertyChanged;

        [NotifyPropertyChangedInvocator]
        protected virtual void OnPropertyChanged([CallerMemberName] string propertyName = null)
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
        }
    }
}